; GUI #
; OpenGl Examples->02-OpenGL Viewing and Transformations
include win64a.inc
; --------------- 
WINDOWWIDTH  = 400
WINDOWHEIGHT = 400

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 or\
	 (sizeof WNDCLASSEX)
	push	rax   ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC   ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   )
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax; 
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax; 
	invoke	wglCreateContext,hDC;     OpenGL
	mov	hrc,rax
	invoke	wglMakeCurrent,hDC,eax;   
	mov	r8d,offset light_ambient
        invoke  glLightfv,GL_LIGHT0,GL_AMBIENT
	mov	r8d,offset light_diffuse
        invoke  glLightfv,GL_LIGHT0,GL_DIFFUSE
	mov	r8d,offset light_specular
	invoke  glLightfv,GL_LIGHT0,GL_SPECULAR
	mov	r8d,offset light_position
	invoke  glLightfv,GL_LIGHT0,GL_POSITION
   
	invoke  glEnable,GL_LIGHTING
	invoke  glEnable,GL_LIGHT0
	invoke  glEnable,GL_DEPTH_TEST
	invoke	GLReshape,WINDOWWIDTH,WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
        invoke  glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT

	invoke  glPushMatrix
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1
	movd	xmm0,const20
	invoke  glRotatef

	invoke  glPushMatrix
	movd	xmm2,ebx
	movd	xmm1,const0_5
	movd	xmm0,const_0_75
	invoke  glTranslatef;, -0.75, 0.5, 0.0
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1
	movd	xmm0,const90
	invoke  glRotatef;, 90.0, 1.0, 0.0, 0.0
	movq	xmm1,constd0_85
	movq	xmm0,constd0_275
	invoke  glutSolidTorus,,,15,15
	invoke  glPopMatrix

	invoke  glPushMatrix
	movd	xmm2,ebx
	movd	xmm1,const_0_5
	movd	xmm0,const_0_75
	invoke  glTranslatef;, -0.75, -0.5, 0.0

	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1
	movd	xmm0,const270
	invoke  glRotatef;, 270.0, 1.0, 0.0, 0.0
	movq	xmm1,constd2
	movq	xmm0,constd1
	invoke  glutSolidCone,,,15,15
	invoke  glPopMatrix

	invoke  glPushMatrix
	movd	xmm2,const_1
	movd	xmm1,ebx
	movd	xmm0,const0_75
	invoke  glTranslatef;, 0.75, 0.0, -1.0

	movq	xmm0,constd1
	invoke  glutSolidSphere,,15,15
	invoke  glPopMatrix

	invoke  glPopMatrix
	invoke  glFlush
;   
	invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
GLReshape proc	w:dword, h:dword
local	resultq:QWORD

	mov	w,ecx
	mov	h,edx

	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode,GL_PROJECTION
	invoke  glLoadIdentity

	mov     eax,h
	cmp	w,eax
	ja	@f
	fld	const_2_5
	fimul   h
	fidiv   w
	fstp    resultq
	movq	xmm2,resultq
	fld	const2_5
	fimul   h
	fidiv   w
	fstp    resultq
	movq	xmm3,resultq

	movq	xmm1,constd2_5
	movq	xmm0,constd_2_5	
	jmp	@0
@@:	fld	const_2_5
	fimul	w
	fidiv	h
	fstp	resultq
	movq	xmm0,resultq
	fld	const2_5
	fimul   w
	fidiv   h
	fstp	resultq
	movq	xmm1,resultq
	movq	xmm3,constd2_5
	movq	xmm2,constd_2_5
@0:	invoke  glOrtho,,,,,constd_10,constd10

	invoke  glMatrixMode, GL_MODELVIEW
	invoke  glLoadIdentity
	leave
	retn
GLReshape endp
;------.data--------------------
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  
szClassName	db "Uncle Remus tales:#40 OpenGL Lighting Model",0
FileName	db "br_Rabbit3.cur",0
;float
const0_5	dd 0.5
const_0_5	dd -0.5
const_0_75	dd -0.75
const0_75	dd 0.75
const1		dd 1.0
const_1		dd -1.0
const_2_5	dd -2.5
const2_5	dd 2.5
const20		dd 20.0
const90		dd 90.0
const270	dd 270.0
;double
constd0_275	dq 0.275
constd0_85	dq 0.85
constd1		dq 1.0
constd2		dq 2.0
constd2_5	dq 2.5
constd_2_5	dq -2.5
constd10	dq 10.0
constd_10	dq -10.0

light_ambient  dd 0.0, 0.0, 0.0, 1.0
light_diffuse  dd 0.0, 0.4, 1.5, 1.0
light_specular dd 1.0, 1.0, 1.0, 1.0
;light_position is NOT default value
light_position dd 1.0, 1.0, 1.0, 0.0
end